﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package 
{
	import com.as3facile.DefaultButton;
	import com.formation.actionscript.observateur.EcouteurSujet;
	import com.formation.actionscript.observateur.Sujet;
	import flash.events.MouseEvent;


	import flash.display.Sprite;
	import flash.events.Event;

	import com.demonsters.debugger.MonsterDebugger;


	/**
	 * Exemple d'utilisation du modèle de conception Observer.
	 * 
	 * 
	 * 
	 * @author Matthieu
	 */
	public class Main extends Sprite 
	{
		private var nCpt : int;// compteur pour le sujet
		
		private var nPosX : Number;// position du champ texte
		private var nPosY : Number;// position du champ texte
		
		
		private var oSujet : Sujet;
		
		// les abonnés
		private var oListener3 : EcouteurSujet;
		private var oListener2 : EcouteurSujet;
		private var oListener1 : EcouteurSujet;

		
		
		public function Main() 
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}


		/**
		 * Démarrage de l'application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
            MonsterDebugger.initialize(this);
            MonsterDebugger.trace(this, "Modele de conception : Observateur");		
								
			// construction de la page
			this.setupUI();	
		}
		
		
		
		/**
		 * Création d'un bouton gérer Observer.
		 * 
		 */
		private function setupUI():void
		{
			nPosX = 30;
			nPosY = 25;
			nCpt = 0;
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Lancez Observer !";
			oBtnStart.getObject().x = nPosX;
			oBtnStart.getObject().y = nPosY;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onRunObserver );
			this.addChild(oBtnStart);	
			
			nPosY += 50;
				
			// création du sujet
			oSujet = new Sujet("Daily Planet");
			
			// création d'un écouteur ( sujet en argument )
			oListener1 = new EcouteurSujet("Monsieur Didier", nPosX, nPosY);
			this.addChild(oListener1);
			
			nPosY += 110;
			oListener2 = new EcouteurSujet("Monsieur Yoan", nPosX, nPosY);
			this.addChild(oListener2);
			
			nPosY += 110;
			oListener3 = new EcouteurSujet("Mademoiselle Lucie", nPosX, nPosY);
			this.addChild(oListener3);
			
			// on abonne l'écouteur au sujet.
			oSujet.addListener(oListener1);
			oSujet.addListener(oListener2);
			oSujet.addListener(oListener3);
			

		}
		
		
		/**
		 * Après le click sur le bouton.
		 * 
		 */
		private function onRunObserver(e : MouseEvent) : void 
		{
			this.removeEventListener(MouseEvent.CLICK, onRunObserver);
			nCpt++;

			// désabonnement d'un abonné
			if( nCpt == 4)
			{
				oSujet.removeListener(oListener2);// l'écouteur 2 ne reçoit plus les mises à jour.
				// le sujet lance une notification - les écouteurs sont prévenus du changement d'état du sujet
				oSujet.addMsg("L'Abonné "+oListener2.getName()+" vient de se désinscrire.");
			}
			
			// le sujet lance une notification - les écouteurs sont prévenus du changement d'état du sujet
			oSujet.setMsg("La nouvelle édition "+nCpt+" vient de paraître ! Consultez-là maintenant dans votre boîte aux lettres.");
		}
	
	}
}
