/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package com.formation.actionscript.observateur 
{
	import flash.display.Sprite;
	import com.actionscriptfacile.ui.text.UITextField;
	

	/**
	 * @author Matthieu
	 * Un écouteur du sujet.
	 * 
	 */
	public class EcouteurSujet extends Sprite implements IObservateur 
	{
		private var oText:UITextField;
		private var sIdentifiant:String;
		
		
		/**
		 * Constructeur
		 * 
		 * @param sMsg : identifiant du sujet
		 * @param nX : position du champ texte
		 * @param nY : position du champ texte
		 */
		public function EcouteurSujet ( sMsg:String, nX:Number, nY:Number )
		{
			sIdentifiant = sMsg;
			oText = this.addText( sIdentifiant );
			oText.x = nX;
			oText.y = nY;
			
			this.addChild(oText);
		}
		
	
		/**
		 * Fonctions obligatoires, à implementer par tous les écouteurs (observateurs).
		 * 
		 */
		public function update(oSujet : Observateur, oInfo : Object) : void 
		{
			oText.text = sIdentifiant+" : nouveau message du "+oSujet.getName()+" - "+oInfo.msg;
		}

		
		/**
		 * Renvoie l'identifiant de l'abonné.
		 * 
		 */
		public function getName() : String
		{
			return sIdentifiant;
		}

		
		/**
		 * 
		 */
		public function destroy() : void 
		{

		}
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeNone();
			
			oTxtField.wordWrap = true;
			//oTxtField.multiline = true;// plusieurs lignes dans le champ texte
			oTxtField.maxHeight = oTxtField.height = 80;
			oTxtField.maxWidth = oTxtField.width = 450;
			
			
			oTxtField.background = true;
			oTxtField.backgroundColor = Math.random()*0xffffff;
			
			oTxtField.changeFormat("size", 15);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", Math.random() *0X006f77);// changement de la couleur
			
			return oTxtField;	 	 
		}
	}
}
