/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package com.formation.actionscript.observateur 
{

	/**
	 * @author Matthieu
	 * Le sujet écouté par des Observateurs.
	 * Le sujet, l'éditeur de magazines.
	 * 
	 */
	public class Sujet extends Observateur 
	{
		private var _sMsg : String = "";
		private var _sBuffer : String = "";
		
		public function Sujet( sIdentifiant:String) 
		{
			super();
			sName = sIdentifiant;
		}
		

		/**
		 * Ajoute un message supplémentaire à transmettre aux abonnés.
		 * 
		 */
		public function addMsg (sText : String):void
		{
			_sBuffer = sText;
		}
		
				
		/**
		 * Modifie le sujet.
		 * 
		 */
		public function setMsg (sText : String):void
		{
			_sMsg = sText + _sBuffer;
			_sBuffer = "";
			
			setChanged();// on indique que l'état du sujet a changé.
			
			var oInfo : Object = new Object();
			oInfo.msg = _sMsg;
			
			notifyListener(oInfo);// on notifie les observateurs du sujet.
			
		}


		/**
		 * Pour limiter le nombre d'abonnés maximum au journal.
		 * 
		 *
		override public function addListener (oListener : IObservateur) : Boolean
		{
			if( this.getNumberListeners() > 200 )
			{
				var oInfo : Object = new Object();
				oInfo.msg = "Désolé, le nombre maximum d'abonnés au journal est attient.";
				 
				oListener.update(this, oInfo);
				return false;
			}
				
			return super.addListener(oListener);
				
		}*/
		
		
		/**
		 * Complète le désabonnement avec un ajout de fonctionnalités.
		 * Préviens l'abonné que sa désinscription a bien été prise en compte.
		 * 
		 * Supprime un écouteur ou observateur.
		 * 
		 */
		override public function removeListener (oListener : IObservateur) : Boolean
		{
			// appel removeListener
			var bDesabo:Boolean = false;
			
			bDesabo = super.removeListener(oListener);
			
			var oInfo : Object = new Object();
			
			// informe l'écouteur
			if( bDesabo )
				oInfo.msg = "Votre désabonnement a bien été pris en compte.";
			else
				oInfo.msg = "Il y a eu une erreur durant votre processus de désabonnement! Contactez-nous par mail svp.";

			oListener.update(this, oInfo);
							
			return bDesabo;			
		}
	}
}
